
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Checklist_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const checklist_items = await db.checklist_items.create(
            {
                id: data.id || undefined,
        
        item_title: data.item_title
        ||
        null
            ,
            
        sequence_order: data.sequence_order
        ||
        null
            ,
            
        item_type: data.item_type
        ||
        null
            ,
            
        instructions: data.instructions
        ||
        null
            ,
            
        link_url: data.link_url
        ||
        null
            ,
            
        is_required: data.is_required
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await checklist_items.setChecklist( data.checklist || null, {
            transaction,
        });
        
        await checklist_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.checklist_items.getTableName(),
                belongsToColumn: 'attachment_files',
                belongsToId: checklist_items.id,
            },
            data.attachment_files,
            options,
        );
        

        return checklist_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const checklist_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                item_title: item.item_title
            ||
            null
            ,
            
                sequence_order: item.sequence_order
            ||
            null
            ,
            
                item_type: item.item_type
            ||
            null
            ,
            
                instructions: item.instructions
            ||
            null
            ,
            
                link_url: item.link_url
            ||
            null
            ,
            
                is_required: item.is_required
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const checklist_items = await db.checklist_items.bulkCreate(checklist_itemsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < checklist_items.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.checklist_items.getTableName(),
                    belongsToColumn: 'attachment_files',
                    belongsToId: checklist_items[i].id,
                },
                data[i].attachment_files,
                options,
            );
        }
        

        return checklist_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const checklist_items = await db.checklist_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.item_title !== undefined) updatePayload.item_title = data.item_title;
        
        
        if (data.sequence_order !== undefined) updatePayload.sequence_order = data.sequence_order;
        
        
        if (data.item_type !== undefined) updatePayload.item_type = data.item_type;
        
        
        if (data.instructions !== undefined) updatePayload.instructions = data.instructions;
        
        
        if (data.link_url !== undefined) updatePayload.link_url = data.link_url;
        
        
        if (data.is_required !== undefined) updatePayload.is_required = data.is_required;
        
        
        updatePayload.updatedById = currentUser.id;

        await checklist_items.update(updatePayload, {transaction});

        
        
        if (data.checklist !== undefined) {
            await checklist_items.setChecklist(
              
              data.checklist,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await checklist_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.checklist_items.getTableName(),
                belongsToColumn: 'attachment_files',
                belongsToId: checklist_items.id,
            },
            data.attachment_files,
            options,
        );
        

        return checklist_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const checklist_items = await db.checklist_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of checklist_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of checklist_items) {
                await record.destroy({transaction});
            }
        });


        return checklist_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const checklist_items = await db.checklist_items.findByPk(id, options);

        await checklist_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await checklist_items.destroy({
            transaction
        });

        return checklist_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const checklist_items = await db.checklist_items.findOne(
            { where },
            { transaction },
        );

        if (!checklist_items) {
            return checklist_items;
        }

        const output = checklist_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.checklist = await checklist_items.getChecklist({
            transaction
        });
        
        
        output.attachment_files = await checklist_items.getAttachment_files({
            transaction
        });
        
        
        output.organizations = await checklist_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.checklists,
        as: 'checklist',
        
        where: filter.checklist ? {
          [Op.or]: [
            { id: { [Op.in]: filter.checklist.split('|').map(term => Utils.uuid(term)) } },
            {
              checklist_name: {
                [Op.or]: filter.checklist.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachment_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.item_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'checklist_items',
                        'item_title',
                        filter.item_title,
                    ),
                };
            }
            
            if (filter.instructions) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'checklist_items',
                        'instructions',
                        filter.instructions,
                    ),
                };
            }
            
            if (filter.link_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'checklist_items',
                        'link_url',
                        filter.link_url,
                    ),
                };
            }
            

            
            

            
            if (filter.sequence_orderRange) {
                const [start, end] = filter.sequence_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sequence_order: {
                    ...where.sequence_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sequence_order: {
                    ...where.sequence_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.item_type) {
                where = {
                    ...where,
                item_type: filter.item_type,
            };
            }
            
            if (filter.is_required) {
                where = {
                    ...where,
                is_required: filter.is_required,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.checklist_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'checklist_items',
                        'item_title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.checklist_items.findAll({
            attributes: [ 'id', 'item_title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['item_title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.item_title,
        }));
    }

    
};

